function that=lincombine(arg1,arg2,c1,c2)
%compute c1*arg1+c2*arg2

% TEST
%     a=deflate(eye(3));
%     b=deflate(ones(3,3));
%     disp('a+b');
%     disp(full(a+b));
%     disp('a-b');
%     disp(full(a-b));
%     disp('-b')
%     disp(full(-b));
%     disp('b+10*a')
%     disp(full(b+10*a));



if strcmp(class(arg1),'deflatev') && strcmp(class(arg2),'deflatev')
    that=deflateWithDeflate(arg1,arg2,c1,c2);
    return
end
if strcmp(class(arg1),'deflatev') 
    that=deflateWithNumber(arg1,arg2,c1,c2);
else
    that=deflateWithNumber(arg2,arg1,c2,c1);
end

%__________________________________________________________________________
function that=deflateWithDeflate(vec1,vec2,c1,c2)
if length(vec1)~=length(vec2)
    error('Adding vectors of different size is not allowed');
end
that=emptycopy(vec1);
S=get(vec1,'segmentsize');
N=numel(vec1);
strt=1;
while strt<=N
    last=min(strt+S-1,N);
    rng=[strt;last]; %1 segment
    data1=getclosedrange(vec1,rng);
    data2=getclosedrange(vec2,rng);
    that=setclosedrange(that,rng,c1*data1+c2*data2);
    strt=last+1;
end

%__________________________________________________________________________
function that=deflateWithNumber(vec1,cnst,c1,c2)

if strcmp(class(cnst),'deflate') ||~isnumeric(cnst) ||length(cnst)>1
    error('method plus only allows addition of constant or vectot of identical size');
end
that=emptycopy(vec1);
S=get(vec1,'segmentsize');
N=numel(vec1);
strt=1;
while strt<=N
    last=min(strt+S-1,N);
    rng=[strt;last]; %1 segment
    data1=getclosedrange(vec1,rng);
    that=setclosedrange(that,rng,c1*data1+c2*cnst);
    strt=last+1;
end
    
