function [offsets,blks]=getOffsets(linIndices,N)
% getOffsets - get offset relative to start of segment 
%              and segment number
% INPUT
%     linIndices(n x 1)
%     N: segment size (number of elements per segment)
%
% OUTPUT
%     offsets(nx1) UINT32
%     blks(nx1)    UINT16


if ~strcmp(class(linIndices),'uint32')
    linIndices=uint32(linIndices);
end
offsets=1+rem(linIndices-1,N); 
%offsets:    1 2 ... 0 1 2 ..
%linIndices: 1 2 3  
blks=(1+(linIndices-offsets )/N);  %==> uint32
blks=uint16(blks);  %==> uint32
%blks:       0 0 0 ... 1 1 1 ...
