function rng=verifyRange(rng)
% verifyRange - check specified ranges for putrange and getrange
%               delete empty ranges
%               join adjacent ranges


%Check size of range: not empty and even number of elements
if isempty(rng)
    return
end
if rem(numel(rng),2)
    error('Ranges must be specified in pairs');
end

%reshape to row 1 (start) and row 2 (end)
rng=reshape(rng,2,numel(rng)/2);

%delete empty ranges
f_notempty=find(rng(2,:)>=rng(1,:));
rng=rng(:,f_notempty);

rng=double(rng);

%join adjacent ranges
for k=size(rng,2):-1:2
	if rng(1,k)==(rng(2,k-1)+1)
		rng(2,k-1)=rng(2,k);
		rng(:,k)=[];
	end
end

%check for illegal range indices
if any(rem(rng(:),1)) || any(rng(:)<1)
    error('Subscript indices must be real positive integers');
end
