function obj=subsasgn(obj,ind,data)
% subsasgn - assign new valuess in deflated vector
% 
%CALL
%  obj=subsassgn(obj,ind,data)
%
%INPUT
%  obj: compressed array
%
%  ind: struct array with fields
%         type: '()'
%         subs: cell array with subscript sets
%
switch numel(data)
    case 0        
        if strcmp(ind.subs,':')            
            error('assignmen M(I)=: not yet supported');
        end
        if isempty(ind.subs{1})
            return
        end                
        error('assignmen M(I)=[] not yet supported');
    case 1
        if strcmp(ind.subs,':')            
            %Implement efficient way to initialize matrix
            
            %warning needed?
            if ~strcmp(class(data),obj.dataclass)
                warning('datatype %s stored as %s, possible loss of data',class(data),obj.dataclass);
                FILLVALUE=obj.value; %change to correct type                
            end
            FILLVALUE(1)=data;
                
            %set all elements to identical value
            %any "full" segments needed?
            %how many "full" segments needed?      
            Nfull=floor((numel(obj)-1)/obj.segmentSize);
            
            %DEFINE SEGMENT
            fullSeg=emptysegment(obj.storemode,FILLVALUE,obj.segmentSize);
            for k=Nfull:-1:1
                obj.segment(k)=fullSeg;
            end
            
            %what is size of last segment?
            N_remaining=rem(numel(obj),obj.segmentSize);
            if N_remaining
                obj.segment(Nfull+1)=emptysegment(obj.storemode,FILLVALUE,N_remaining);
            end            
            return
        end
end

if ind(1).type(1)~='(' || length(ind)>1 || length(ind.subs)>1
    error('Subscripts in compressed vector should be of form: M(I1)');    
end

if ~strcmp(class(data),obj.dataclass)
    warning('datatype %s stored as %s, possible loss of data',class(data),obj.dataclass);    
end

% replace ':' with numberic equivalent
% if number of indices is higher then number of dimensions of array, assume
% 1 for missing dimensions (this may or may not lead to OOB warning)
% extend size vector with singleton dimensions if needed

% replace ':' with numeric equivalent
if strcmp(ind.subs,':')
    obj=copy2Vector(obj,data);
    return
end

linIndices=ind.subs{1};

if numel(data)~=numel(linIndices)
    error('In an assignment  A(I) = B, the number of elements in B and I must be the same.')
end

[offsets,blks]=getOffsets(linIndices,obj.segmentSize);
%data       (Nx1): data to assign
%linIndices (Nx1): indices into full vector
%offsets    (Nx1): indices within segment
%blks       (Nx1 : segment index 

if sortedindex(linIndices)
    %indices were sorted
    SORTEDINDEX=true;
    [unqSegments,RANGE]=groupIndex(blks,obj.segmentSize);
    %     unqSegments: group number
    %     RANGE: first and last index of group
else
    %indices were unsorted
    SORTEDINDEX=false;
    unqSegments=unique(blks);
end

for BLKINDX=1:length(unqSegments)
    blk=unqSegments(BLKINDX);
    %find out which elements will be assigned to this block.
    
    if SORTEDINDEX
        f_data=RANGE(BLKINDX,1):RANGE(BLKINDX,2);
        %GET OFFSETS USED WITH CURRENT SEGMENT
        thisOffsets=offsets(f_data);
        firstOffset = thisOffsets(1);
        lastOffset  = thisOffsets(end);
    else
        f_data=find(blks==blk);
        thisOffsets=offsets(f_data);
        firstOffset = min(thisOffsets);
        lastOffset  = max(thisOffsets);
    end     
    % f_data: index to blks,offsets,data. Elements to assign to this block
    %    f_data is not empty
        
    %RETREIVE SEGMENT DATA PAD NONEXISTING DATA WITH ZEROS
    [segdata,range]=importUnion(obj,blk,firstOffset,lastOffset);
    
    %MODIFY SEGMENT
    segdata(thisOffsets-(range(1)-1))=data(f_data);

    %STORE SEGMENT
    %NOTE: if blk extends the number of blocks, earlier blocks may
    %remain unitialized. (data=[] & range=[])
    obj.segment(blk)=storeSegment(obj.storemode,segdata,range);
end
%____________________________________________________________
function  obj=copy2Vector(obj,data)
%efficient way to fill vector
if numel(obj)~=numel(data)
    error('In an assignment  A(I) = B, the number of elements in B and I must be the same.');
end

%initialize output
NOW=now;
TGAP=5/(1440*60);
hwait=[];

%-all segments are present already
%-they may or may not be initialized
for blk=1:length(obj.segment)
    hwait=waitbarc((now-NOW)>TGAP,blk/length(obj.segment),hwait,'Store');
    
	%     segment=obj.segment(blk); %WIJZ ZIJPP MAY 2006
    %modify segment: note the size should not change unless entire block
    %was empty
    if blk<length(obj.segment)
        %this is a "full" block ==> overwrite obj.segmentSize
        %elements        
        rng=(blk-1)*obj.segmentSize + (1:obj.segmentSize);
    else
        %this will be the last block
        %not change size
        rng=((blk-1)*obj.segmentSize+1) : length(data);        
    end
    obj.segment(blk)=storeSegment(obj.storemode,data(rng),[1,length(rng)]);
end
close(hwait);


    
